% Pole distribution of 2nd order polynomials
%
% U. Zoelzer 30.09.1989
%            28.05.1992
%            17.12.2007
clear;
w=input('Wordlength of coefficients w =  ');
q=exp(-1*(w-1)*log(2));
n=2*round(1/q);
k=1;
for i=1:n
    for j=1:n
        re(k)=(i-1)*q/2;
        x=j*q-re(k).^2;
        if x>0 
           if (x+re(k).^2) <= 1 
              im(k)=sqrt(x);
              k=k+1;
              end;
        end;
	end;
end;
re(k)=1;
im(k)=1;
for i=1:n
    for j=1:n
        re(k)=-i*q/2;
        x=j*q-re(k).^2;
        if x>0 
           if (x+re(k).^2) <= 1 
              im(k)=sqrt(x);
              k=k+1;
              end;
        end;
	end;
end;
re(k)=1;
im(k)=1;

figure(1)
t=(1:250);
t=2*pi*t/250;
plot(sin(t),cos(t));
hold on
plot(0:1/50:1);
plot(re,im,'.',re,-im,'.');
title('Z-plane');
xlabel('Re\{z\} \rightarrow'),ylabel('Im\{z\} \rightarrow');
v=[-1,1,-1,1];
axis(v);
axis('square');

clear re im k;
k=1;
for i=1:n
    for j=1:n
        re(k)=(i-1)*q;
        im(k)=(j-1)*q;
        if (im(k).^2+re(k).^2) <= 1 
              k=k+1;
              end;
        end;
end;
re(k)=1;
im(k)=1;
for i=1:n
     for j=1:n
        re(k)=-i*q;
        im(k)=(j-1)*q;
        if (im(k).^2+re(k).^2) <= 1 
              k=k+1;
              end;
        end;
end;
 
re(k)=1;
im(k)=1;

figure(2)
t=(1:250);
t=2*pi*t/250;
plot(sin(t),cos(t));
hold on
plot(0:1/50:1);
plot(re,im,'.',re,-im,'.');
title('Z-plane');
xlabel('Re\{z\} \rightarrow'),ylabel('Im\{z\} \rightarrow');
v=[-1,1,-1,1];
axis(v);
axis('square');

clear re im k;
k=1;
for i=1:n
    for j=1:n
        re(k)=(2-i*j*q.^2-(i*q).^2)/2;
        x=1-i*j*q.^2-re(k).^2;
        if x>0 
           if (x+re(k).^2) <= 1 
              im(k)=sqrt(x);
              k=k+1;
              end;
        end;
	end;
end;
re(k)=1;
im(k)=1;

figure(3)
t=(1:250);
t=2*pi*t/250;
plot(sin(t),cos(t));
hold on
plot(0:1/50:1);
plot(re,im,'.',re,-im,'.');
title('Z-plane');
xlabel('Re\{z\} \rightarrow'),ylabel('Im\{z\} \rightarrow');
v=[-1,1,-1,1];
axis(v);
axis('square');

clear re im k;
k=1;
for i=1:n
    for j=1:n
        re(k)=(2-i*j*q.^2-(i*q).^3)/2;
        x=1-i*j*q.^2-re(k).^2;
        if x>0 
           if (x+re(k).^2) <= 1 
              im(k)=sqrt(x);
              k=k+1;
              end;
        end;
	end;
end;
re(k)=1;
im(k)=1;

figure(4)
t=(1:250);
t=2*pi*t/250;
plot(sin(t),cos(t));
hold on
plot(0:1/50:1);
plot(re,im,'.',re,-im,'.');
title('Z-plane');
xlabel('Re\{z\} \rightarrow'),ylabel('Im\{z\} \rightarrow');
v=[-1,1,-1,1];
axis(v);
axis('square');
